
const { ccclass, property } = cc._decorator;

@ccclass
export default class Water extends cc.Component {
    @property(cc.RigidBody)
    rigidBody: cc.RigidBody = null;

    @property(cc.Vec2)
    initialVelocity: cc.Vec2 = cc.v2(0, -300); // 初始速度

    onLoad() {

        //   // 在水滴生成时，为其添加初始速度
        //   const parentVelocity = this.node.getComponent(cc.RigidBody).linearVelocity;
        //   const initialVelocity = cc.v2(parentVelocity.x, parentVelocity.y - 200); // 初始速度为父节点速度的基础上向上偏移
        //   this.rigidBody.linearVelocity = initialVelocity;


        // // 设置初始速度
        // this.rigidBody.linearVelocity = this.initialVelocity;
        //   // 应用重力
        //   const gravity = cc.v2(0, -980); // 重力加速度
        //   this.rigidBody.applyForceToCenter(gravity.mul(this.rigidBody.getMass()), true);
        // this.node.setParent(cc.find('Canvas'))

    }

    desFunction: Function = null;
    protected onEnable(): void {
        if (this.desFunction) { this.unschedule(this.desFunction) }
        this.desFunction = () => this.scheduleOnce(() => {
            // const gravity = cc.v2(0, -980); // 重力加速度
            // // this.rigidBody.type = cc.RigidBodyType.Dynamic;//.t
            // this.rigidBody.applyForceToCenter(gravity.mul(this.rigidBody.getMass()), false);
              this.node.destroy();
            // PoolManager.getInstance().putNodeToMap(Pool_Name.CAT_BATH_WATER_POOL, this.node);
        }, 3)
        this.desFunction();
    }

    protected onDisable(): void {
        this.node.destroy();
        // PoolManager.getInstance().putNodeToMap(Pool_Name.CAT_BATH_WATER_POOL, this.node);

    }

    // update(dt) {
    //     // 在update函数中可以对水滴进行一些额外的操作，例如应用重力、检测碰撞等
    //     //cc.log(-this.node.angle)
    //     // const gravity = cc.v2(0, -980); // 重力加速度
    //     // this.rigidBody.applyForceToCenter(gravity.mul(this.rigidBody.getMass()), false);

    // }


    // 这两个是对象池使用的
    unuse() {
        //console.log('对象池停止使用')
    }
    reuse() {
        //console.log('对象池再次使用')
    }
}
